

		glUseProgram( pidhole09 );
		gluniformmatrix4fv( mvpid09, 1, gl_false, imvp(1,1)'address );
		gluniform1i(sampid09,0);

		if success then
			gluniform1i(lFlagid09,1); -- 1=>use light effects
			gluniform3f(lColrid09, 246.0/255.0, 216.0/255.0, 11.0/255.0 ); --gold
			glUniform1i(darkid09, castledarkness); -- was -1
			gluniform1f(lspcid09, 0.5); --fracMspc (dflt=0.1)
		else
			gluniform1i(lFlagid09,0); -- 0=>NO light effects
			gluniform3f(lColrid09, 123.0/255.0, 108.0/255.0, 6.0/255.0 ); --dgold
			glUniform1i(darkid09, castledarkness);
		end if;

		gluniform3f(lPosid09, glfloat(xchalice),glfloat(ychalice),glfloat(zchalice) );

		gluniform3f(eyeid09, glfloat(xeye),glfloat(yeye),glfloat(zeye) );


		gluniform1i(flevid09, foglev2 ); 
		gluniform1i(fcolid09, fogclr2 ); 

		glUniform1f(radid09, 0.0 );
		glbindtexture(gl_texture_2d, adobe_texid); --13oct16
		cylobj.draw(iskylight, vertbuff,uvbuff,elembuff);


